/***********************************************************************
*                                                                      *
* (C) 2006, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file condition.h
  \brief Condition
  
  \author Frank Lemke
  \date 2006-02-27
*/

#ifndef CONDITION_H_
#define CONDITION_H_

#include <string>
#include <cstdlib>

using namespace std;

/*!
 \brief Condition-object

 Condition-object with automatically created id to store name and input sequence of a condition. The input sequence consists of a string of 0,1 or x (don't care) values with length equal to the number of inputs of the Fsm.

*/

class Condition {

 public:
  string cname;
  int cid;
  string input;
  

  Condition(int id, int numberOfInputs);
  ~Condition(){};
  Condition &operator=(const Condition &con);
  int operator==(const Condition &con) const;
  int operator<(const Condition &con) const;


};


#endif
