/***********************************************************************
*                                                                      *
* (C) 2006, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file link.h
  \brief Link
  
  \author Frank Lemke
  \date 2006-02-27
*/

#ifndef LINK_H_
#define LINK_H_

#include <utility>
#include <string>
#include <cstdlib>

using namespace std;

/*!
  \brief Link-object

  Link is a shortcut to a State. A Trackpoint can directly be connected
  to it.
*/
 
class Link {

 public:
  int lid;
  int goal;
  pair <double , double>  linkpos;
  int color;
  int hlevel;

  Link(int id, double posx, double posy, int target, int level);
  ~Link(){};
  Link &operator=(const Link &li);
  int operator==(const Link &li) const;
  int operator<(const Link &li) const;

};


#endif
