/***********************************************************************
*                                                                      *
* (C) 2006, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                            *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <cstdlib>
#include <sstream>

#include "state.h"

using namespace std;


State::State(int id, int numberOfOutputs) {
  sid = id;
  pos.first = 10;
  pos.second = 10;
  hlevel = 0;
  sname = "state_";
  sname = sname + itos(sid);
  output = "";
  output.assign(numberOfOutputs, '0');
  color = 4294901760;
  
}



State& State::operator=(const State &sta){
  this->sname = sta.sname;
  this->pos.first = sta.pos.first;
  this->pos.second = sta.pos.second;
  this->hlevel = sta.hlevel;
  this->sid = sta.sid;
  this->color = sta.color;
  this->output = sta.output;
  return *this;
}

int State::operator==(const State &sta) const{
  if(sid == sta.sid) return 1;
  return 0;

}

int State::operator<(const State &sta) const{
  if(sid < sta.sid) return 1;
  return 0;

}

string State::itos(int i) {
  stringstream s;
  s << i;
  return s.str();

}

