/***********************************************************************
*                                                                      *
* (C) 2006, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file state.h
  \brief State
  
  \author Frank Lemke
  \date 2006-02-28
*/

#ifndef STATE_H_
#define STATE_H_

#include <utility>
#include <string>
#include <cstdlib>

using namespace std;

/*!
  \brief State-object

  The State-object stores all informations about a FSM-state.
  Consists of internal ID, statename, hierarchylevel, position, color 
  and outputvalues. 
*/
 
class State {

 public:
  string sname;
  pair <double, double> pos;
  int hlevel;
  int sid;
  string output;
  unsigned int color;

  State(int id, int numberOfOutputs);
  ~State(){};
  string itos(int i);
  State &operator=(const State &sta);
  int operator==(const State &sta) const;
  int operator<(const State &sta) const;


};

#endif
