/***********************************************************************
*                                                                      *
* (C) 2006, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <cstdlib>
#include <sstream>

#include "trackpoint.h"

using namespace std;


Trackpoint::Trackpoint(int id, double posx, double posy, int hl) {
  trid = id;
  pos.first = posx;
  pos.second = posy;
  hldirection = hl;
  hlevel = hl;
  link = false;
  lid = 0;
  join = false;
  color = 0;
}

Trackpoint& Trackpoint::operator=(const Trackpoint &tra) {
  this->pos.first = tra.pos.first;
  this->pos.second = tra.pos.second;
  this->trid = tra.trid;
  this->link = tra.link;
  this->lid = tra.lid;
  this->hldirection = tra.hldirection;
  this->hlevel = tra.hlevel;
  this->join = tra.join; 
  this->color = tra.color;
}

int Trackpoint::operator==(const Trackpoint &tra) const {
  if(trid == tra.trid) return 1;
  return 0;
}

int Trackpoint::operator<(const Trackpoint &tra) const {
  if(trid < tra.trid) return 1;
  return 0;
}

