/***********************************************************************
*                                                                      *
* (C) 2006, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file trackpoint.h
  \brief Trackpoint
  
  \author Frank Lemke
  \date 2006-02-27
*/

#ifndef TRACKPOINT_H_
#define TRACKPOINT_H_

#include <utility>
#include <string>
#include <cstdlib>

using namespace std;

  /*!
    \brief Trackpoint-object

    First of all it is a point of a Transition. But it is also
    possible to connect it to a Link and provides the functionality
    to expand this transitionpoint to a hierarchical-state.
  */

class Trackpoint {

 public:
  pair <double, double> pos;
  int hldirection;
  int hlevel;
  int trid;
  bool link;
  int lid;
  bool join;
  int color;

  Trackpoint(int id, double posx, double posy, int hl);
  ~Trackpoint(){};
  Trackpoint &operator=(const Trackpoint &tra);
  int operator==(const Trackpoint &tra) const;
  int operator<(const Trackpoint &tra) const;


};

#endif
