/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file core_I.h
  \brief Core_I
  
  \author Frank Lemke
  \date 2006-02-28
*/

#ifndef CORE_I_H_
#define CORE_I_H_


#include <string>
#include "fsm_I.h"
#include "XercesDefinitions.hpp"



using namespace std;

/*!
  \brief Core_Interface
  
  Interface which provides the functions to add, delete or get FSMs.
*/
class Core_I {
 public:
  virtual void projectName(string pname) = 0;
  virtual string getProjectName() = 0;
  virtual void addFsm() = 0;
  virtual void deleteFsm(int id) = 0;
  virtual void reset() = 0;
  virtual bool getFirstFsm() = 0;
  virtual bool getNextFsm() = 0;
  virtual bool setCurrentFsm(int id) = 0;
  virtual Fsm_I& getCurrentFsm() = 0;
  virtual Fsm_I& getFsm(int i) = 0;
  virtual bool isFsm() = 0 ;
};



#endif
