/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file corefactory.h
  \brief CoreFactory
  
  \author Frank Lemke
  \date 2006-02-28
*/

#ifndef COREFACTORY_H_
#define COREFACTORY_H_


#include "core_I.h"
#include "core/core.h"


using namespace std;

/*!
  \brief CoreFactory
  
  FactoryClass to make the static core-object available.
*/

class CoreFactory {
  static Core c;
 public:
  
  /*!
    \brief getCore_I

    Function to return core_Interface for working with static core-object.
  \return Core_I& Core_I reference.  
  */ 
  static Core_I& getCore_I();
};


#endif
