/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <QtGui/QApplication>
#include <QtCore/QDir>
#include <QtGui/QSplashScreen>


#include "fsmdesigner.h"
#include "gui/mainguiwindow.h"

/// Settings
QSettings * fsmDesignerSettings;

int main( int argc, char ** argv )
{
	// Prepare Application
    QApplication a( argc, argv );
    printf("argv[0]: %s\n",argv[0]);
    Q_INIT_RESOURCE(icons); 
    QPixmap logo(":/icons/FSMDesignerlogo.png");
    QSplashScreen* ss = new QSplashScreen(logo);   
    ss->show();

    // Prepare Settings
    fsmDesignerSettings = new QSettings("FSMDesigner","LSRA");

    // Show GUI
    MainguiWindow w;   
    if(argc > 1) {
      string s = argv[1];
      if((strcmp(s.c_str(),"-s") == 0) || (strcmp(s.c_str(),"-S") == 0)) {
	w.load();
	w.simulation(1,0);
      }
    }
    w.show();
    ss->finish(&w);
    delete ss;
    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    return a.exec();
}
