/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#ifndef GENERATIONOFVERILOG_H_
#define GENERATIONOFVERILOG_H_


#include <string>
#include <iostream>
#include <vector>

#include <QtCore/QStringList>
#include <QtCore/QDebug>

using namespace std;

class GenerationOfVerilog {

 public:
  GenerationOfVerilog(string str, string stri, bool gui, bool st, bool sc, bool tc);
  ~GenerationOfVerilog() {};
  QWidget* wid;
  void setMainWidget(QWidget* w);

 private:
  string fsmdata;
  string optionalpath;
  string modulename;
  int resetstate;
  int reset;
  int clock;
  int numberofinputs;
  int numberofoutputs;
  string xorDifference;
  int desired_distance;
  int min_distance;
  int ext_min_distance;
  int extendedBy;
  int current_extension_int;
  QString current_extension_string;
  bool g;
  
  bool Statetrans;
  bool Statecov;
  bool Transcov;

  void createVerilog();
  void calcHammingDistance();
  int calcExtendedHammingDistance(QString testedString);
  int  calcXOR(string stringA, string stringB );
  void extendStateEncoding();
  void createStateVariations();
  QStringList originalStateOutputs;
  QStringList originalStateNames;
  vector<int> originalStateName_index;
  QStringList extendedStateEncoding;

  bool wanttogenver();
  string getVerilogFilename();
};






#endif
