/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <QtGui/QApplication>
#include <string>
#include <iostream>

#include "generationofverilog.h"

using namespace std;

void cmdsyntaxerror()
{
	cout<<"Usage: fsmveriloggeneration [gui] infile outfile [statetransition statecoverage transcoverage]"<< endl;
	cout<<"       (gui, statetransition, statecoverage, transcoverage are boolean values)"<< endl;
};

int main( int argc, char ** argv ) {
  QApplication a( argc, argv );  
  string st;
  string s;
  bool c1;
  bool c2;
  bool c3;

  if(argc<3) {
    cmdsyntaxerror();
    return -1;
  } else {
    if(strcmp(argv[1],"gui")==0) {
      if(argc > 3) {
	if(argc > 6) { 
	  if(strcmp(argv[6],"true")==0) {
	    c3 = true;
	  } else {
	    c3 = false;
	  }
	  if(strcmp(argv[5],"true")==0) {
	    c2 = true;
	  } else {
	    c2 = false;
	  }
	  if(strcmp(argv[4],"true")==0) {
	    c1 = true;
	  } else {
	    c1 = false;
	  }
	  st = argv[3];
	  s = argv[2];
	  GenerationOfVerilog g(s,st,true,c1,c2,c3);
	  return 0;
	} else if (argc == 4) {
	  s = argv[2];
	  st = argv[3];
	  GenerationOfVerilog g(s,st,true,false,false,false);
	  return 0;
	} else {
	  cmdsyntaxerror();
	  return -1;
	}
      } else {
	cmdsyntaxerror();
	return -1;
      }
    } else { 
	if(argc > 5) {
	  if(strcmp(argv[5],"true")==0) {
	    c3 = true;
	  } else {
	    c3 = false;
	  }
	  if(strcmp(argv[4],"true")==0) {
	    c2 = true;
	  } else {
	    c2 = false;
	  }
	  if(strcmp(argv[3],"true")==0) {
	    c1 = true;
	  } else {
	    c1 = false;
	  }
	  st = argv[2];
	  s = argv[1];
	  GenerationOfVerilog g(s,st,false,c1,c2,c3);
	  return 0;
	} else {
	  if(argc > 3) {
	    cmdsyntaxerror();
	    return -1;
	  } else {
	    st = argv[2];
	    s = argv[1];
	    GenerationOfVerilog g(s,st,false,false,false,false);	
	    return 0;
	  }
	}
    }
  }
}

