/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "deleteconditiontrans.h"

#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"


DeleteConditionTrans::DeleteConditionTrans(QWidget* w){
  setupUi(this);
  qw = w;
  Core_I& core = CoreFactory::getCore_I();  
  Fsm_I& fsm = core.getCurrentFsm();
  int i = dynamic_cast<MainguiWindow*>(qw)->getPropertiesID();
  fsm.getTransbyID(i);
  int count = 0;
  if(fsm.getTransFirstCondition()) {
    do {
      string s = fsm.getTransConditionName();
      QString qs = QString::fromStdString((dynamic_cast<MainguiWindow*>(qw))->itos(count)) + " " +  QString::fromStdString(s);
      conditionnamelist->insertItem(count++,qs);
    } while (fsm.getTransNextCondition());
  }
  if(count == 0) {
    okButton->setEnabled(false);
  }
}

void DeleteConditionTrans::accept() {
  Core_I& core = CoreFactory::getCore_I();  
  Fsm_I& fsm = core.getCurrentFsm();
  int deleteid = -1;
  QString select = conditionnamelist->currentText();
  int count = 0;
  if(fsm.getTransFirstCondition()) {
    do {
      string s = fsm.getTransConditionName();
      QString qs = QString::fromStdString((dynamic_cast<MainguiWindow*>(qw))->itos(count)) + " " +  QString::fromStdString(s);
      if(strcmp(qs.toStdString().c_str(),select.toStdString().c_str()) == 0) {
    	  deleteid = fsm.getTransConditionID();
      }
      count++;
    } while (fsm.getTransNextCondition());
  }
  if(deleteid > -1) {
    fsm.deleteConditionOfTrans(dynamic_cast<MainguiWindow*>(qw)->getPropertiesID(), deleteid);
    dynamic_cast<MainguiWindow*>(qw)->propertywidget->doItemsLayout();
  }
  this->done(0);
}
