/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "hierarchyconnector.h"
#include "view.h"

#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

Hierarchyconnector::Hierarchyconnector(QWidget* w) {
  qw = w;
  setupUi(this);
  label->setText("<u>Transition :</u>"); 
  this->setObjectName(QString::fromUtf8("Hierarchyconnector"));
  this->setWindowTitle(QApplication::translate("Hierarchyconnector", "Connect to Trans", 0, QApplication::UnicodeUTF8));
  int i = -1; 
  (dynamic_cast<View*>(qw))->sethelpvar(i);
  Core_I& c = CoreFactory::getCore_I(); 
  Fsm_I& f = c.getCurrentFsm();
  int curlevel = (dynamic_cast<View*>(qw))->getCurrentLevel();
  bool found = false;
  bool write = false;
  bool join = false;
  bool ok = false;
  bool abort = false;
  int pointer = -1;
  double x = 0.1;
  double y = 0.1;
  if(f.getFirstTrans()) {
    do {
      write = false;
      join = false;
      if(f.getTransFirstTrackpoint()) {
	do {
	  if(f.getTransTrackpointJoin()) {
	    join = true;
	    x = f.getTransTrackpointPosx();
	    y = f.getTransTrackpointPosy();
	  }
	  if ((f.getTransTrackpointLevel() != f.getTransTrackpointHldirection()) && (f.getTransTrackpointLevel() != curlevel)) {
	    write = true;
	  } else {
	    write = false;
	  }
	} while (f.getTransNextTrackpoint());
      }
      if(write) {
	if(join) {
	  if(pointer > -1) {
	    ok = true;
	    pointer = f.getTransID();
	    f.getFirstTrans();
	    do {
	      if(f.getTransFirstTrackpoint()) {
		do {
		  if(f.getTransTrackpointJoin()) {
		    if(x == f.getTransTrackpointPosx()) {
		      if(y = f.getTransTrackpointPosy()) {
			while (f.getTransNextTrackpoint()) {}
			abort = true;
		      }
		    }
		  }
		} while (f.getTransNextTrackpoint());
	      }
	      f.getNextTrans();
	      if(abort) {
		f.getTransbyID(pointer);
		abort = false;
		ok = false;
	      }
	    } while (pointer != f.getTransID());
	    if(ok) {
	      found = true;
	      string name = f.getTransName();
	      QString qs = QString::fromStdString(name);
	      idlist->insertItem(i++,qs);
	    }
	  } else {
	    found = true;
	    string name = f.getTransName();
	    QString qs = QString::fromStdString(name);
	    idlist->insertItem(i++,qs);
	    pointer = f.getTransID();
	  }
	} else {
	  found = true;
	  string name = f.getTransName();
	  QString qs = QString::fromStdString(name);
	  idlist->insertItem(i++,qs);
	}
      }
    } while (f.getNextTrans());
  } 
  if(!found) {
    okButton->setEnabled(false);
  }
}

void Hierarchyconnector::accept() {
  Core_I& c = CoreFactory::getCore_I(); 
  Fsm_I& f = c.getCurrentFsm();
  int i = -1;
  string transname = (idlist->currentText()).toStdString();
  if(f.getFirstTrans()) {
    do {
      if(strcmp(transname.c_str(), f.getTransName().c_str()) == 0) {
	i = f.getTransID();
      }
    } while (f.getNextTrans());
  }
  (dynamic_cast<View*>(qw))->sethelpvar(i);
  this->close();
}
