/***********************************************************************
*                                                                      *
* (C) 2009, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <QtGui/QComboBox>
#include <QtGui/QSpinBox>
#include <QtGui/QLineEdit>

#include "colorbutton.h"
#include "statecombobox.h"

#include "inputdelegate.h"
#include "inputmodel.h"
#include "inputwidget.h"
#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

#include <iostream>

using namespace std;

InputDelegate::InputDelegate(QObject* parent) : QStyledItemDelegate(parent), colorEdited(false) {
    type=0; propid=0;
}

InputDelegate::~InputDelegate() {

}

void InputDelegate::paint(QPainter* painter,const QStyleOptionViewItem& option, const QModelIndex& index) const {
    QStyledItemDelegate::paint(painter, option, index);
}

QSize InputDelegate::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const {
    return QStyledItemDelegate::sizeHint(option, index);
}

void InputDelegate::setEditorData(QWidget* editor,const QModelIndex& index) const {

    if (type==2) // transition selector
    {
        QStyledItemDelegate::setEditorData(editor, index);
    }
    else { // all other properties
        QStyledItemDelegate::setEditorData(editor, index);
    }
}
    


void InputDelegate::setParams(int status, int id) {
    type = status;
    propid = id;
}


QWidget* InputDelegate::createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index)  const {
    if ( type==2) //transition editor
    {
        return QStyledItemDelegate::createEditor(parent, option, index);
    }
    else
    {
        return QStyledItemDelegate::createEditor(parent, option, index);
    }
}




void InputDelegate::setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const {

 if (type==2) //state
    {
        QStyledItemDelegate::setModelData(editor, model, index);
    }
    else
        QStyledItemDelegate::setModelData(editor, model, index);

}




