/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "linkconnector.h"
#include "view.h"

#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

Linkconnector::Linkconnector(QWidget* w) {
  qw = w;
  setupUi(this);
  label->setText("<u>Choose Link:</u>"); 
  this->setObjectName(QString::fromUtf8("Linkconnector"));
  this->setWindowTitle(QApplication::translate("Linkconnector", "Connect to Link", 0, QApplication::UnicodeUTF8));
  Core_I& c = CoreFactory::getCore_I(); 
  Fsm_I& f = c.getCurrentFsm();
  int i = -1;
  int i2;
  string s;
  QString qs2;
  (dynamic_cast<View*>(qw))->sethelpvar(i);
  if(f.getFirstLink()) {
      int lid = f.getLinkID();
      i2 = f.getLinkGoal();
      f.getStatebyID(i2);
      s = f.getStateName();
      qs2 = QString::fromStdString(s);
      QString qs = QString::number(lid,10)+"     - with Goal: "+qs2;
      idlist->insertItem(i++,qs);
      while (f.getNextLink()) {
          int lid = f.getLinkID();
          i2 = f.getLinkGoal();
          f.getStatebyID(i2);
          s = f.getStateName();
          qs2 = QString::fromStdString(s);
          QString qs = QString::number(lid,10)+"     - with Goal: "+qs2;
          idlist->insertItem(i++,qs);
      }
  } else {
      okButton->setEnabled(false);
  }
}

void Linkconnector::accept() {
  int i =(idlist->currentText()).left(5).QString::toInt(0,10);
  (dynamic_cast<View*>(qw))->sethelpvar(i);
  this->close();
}
