#ifndef MAINGUI_H_
#define MAINGUI_H_

#include <QtGui/QWhatsThis>
#include <QtGui/QLabel>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDockWidget>
#include <QtGui/QFrame>
#include <QtGui/QGroupBox>
#include <QtGui/QLineEdit>
#include <QtGui/QMainWindow>
#include <QtGui/QMenuBar>
#include <QtGui/QStatusBar>
#include <QtGui/QWidget>

#include "fsmgui.h"
#include "propertiesmodel.h"
#include "propertiesdelegate.h"
#include "inputmodel.h"
#include "inputdelegate.h"
#include "outputmodel.h"
#include "outputdelegate.h"

class Maingui : public Ui_FSMMainWindow {
  


 public:
  
  ////// Simulation dock widget ///////
  
  QDockWidget *simWidget;
  QWidget *simWidgetContents;
  QLabel *label;
  QLineEdit *curtime;
  QGroupBox *simmode;
  QLineEdit *inputvectorvalue;
  QLineEdit *currentstatevalue;
  QLineEdit *nextstatevalue;
  QCheckBox *curstatemode;
  QCheckBox *nextstatemode;
  QCheckBox *transmode;
  QLabel *inputvector;
  QLabel *currentstate;
  QLabel *nextstate;
  QFrame *line_4;
  QFrame *line;
  QFrame *line_2;
  QFrame *line_3;
  QFrame *line_5;

  PropertiesModel* propmodel;
  PropertiesDelegate* propdelegate;
  InputModel* inpmodel;
  InputDelegate* inpdelegate;
  OutputModel* outpmodel;
  OutputDelegate* outpdelegate;
  void setupMaingui(QMainWindow *QMW);
  void setupSimDock(QMainWindow *MW);
  void retranslateSim(QMainWindow *MaW);


private:
  void addonactions(QMainWindow *QMW);
  void initOutputWidget();
  void initInputWidget();
  void initProjectTreeWidget();
  void initPropertyWidget();
  void initOutputEditorWidget();


};


#endif
 
