/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "newfsmname.h"
#include "mainguiwindow.h"

#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

FsmName::FsmName(QWidget* w) {
  qw = w;
  setupUi(this);
}

string FsmName::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}

void FsmName::accept() {
  Core_I& c = CoreFactory::getCore_I();
  c.addFsm();
  Fsm_I& f = c.getCurrentFsm();
  QString qs = lineEditFSMName->text();

  FilterKeywords* fk;
  fk = new FilterKeywords();
  qs = fk->RemoveBlanks(qs);
  qs = fk->FilterSpecialChars(qs);
  qs = fk->FilterBusChars(qs);
  //qs = fk->FilterHDLKeywords(qs);

  string name = QStrToStr(qs);
  f.fsmName(name);
  (dynamic_cast<MainguiWindow*>(qw))->setcurrentfsmid(f.getFsmID());
  (dynamic_cast<MainguiWindow*>(qw))->setcurrenthierarchylevel(0);
  (dynamic_cast<MainguiWindow*>(qw))->activatepmode();  
  (dynamic_cast<MainguiWindow*>(qw))->setActiveProject(true);
  (dynamic_cast<MainguiWindow*>(qw))->refresh();
  (dynamic_cast<MainguiWindow*>(qw))->initFsm();
  this->close();
}
