/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "newlink.h"
#include "view.h"

#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

NewLink::NewLink(QWidget* w) {
  qw = w;
  setupUi(this);
  Core_I& c = CoreFactory::getCore_I(); 
  Fsm_I& f = c.getCurrentFsm();
  int i = 0;
  int count = 0;
  if(f.getFirstState()) {
    if (f.getStateLevel() == (dynamic_cast<View*>(qw))->getCurrentLevel()) {
      count++;
      string s = f.getStateName();
      QString qs = QString::fromStdString(s);;
      statenamelist->insertItem(i++,qs);
    }
    while (f.getNextState()) { 
      if (f.getStateLevel() == (dynamic_cast<View*>(qw))->getCurrentLevel()) {
	count++;
	string s = f.getStateName();
	QString qs = QString::fromStdString(s);;
	statenamelist->insertItem(i++,qs);
      }
    }
  } 
  if(count == 0) {
    okButton->setEnabled(false);
    i = - 1;
    (dynamic_cast<View*>(qw))->sethelpvar(i);
  }
}

void NewLink::accept() { 
  QString qs = statenamelist->currentText();
  string s = QStrToStr(qs);  
  int i = 0;  
  Core_I& c = CoreFactory::getCore_I(); 
  Fsm_I& f = c.getCurrentFsm();
  if(f.getFirstState()) {
    if(strcmp(StrToChar(f.getStateName()), StrToChar(s)) == 0) {
      i = f.getStateID();
    }
    while(f.getNextState()) {
      if(strcmp(StrToChar(f.getStateName()), StrToChar(s)) == 0) {
	i = f.getStateID();
      }
    }
  }
  (dynamic_cast<View*>(qw))->sethelpvar(i);
  this->close();
}

string NewLink::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}

const char* NewLink::StrToChar(string s) {
  char* c;
  c = new char[s.length()+1];
  strcpy(c,s.c_str());
  return c;
}
