/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "newproject.h"
#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"


NewPro::NewPro(QWidget* wid) {
  setupUi(this);
  qwid = wid;
}

void NewPro::accept() {
  
  if((dynamic_cast<MainguiWindow*>(qwid))->getActiveProject()) {
    (dynamic_cast<MainguiWindow*>(qwid))->activeProjectWarning();
  }
  if(!(dynamic_cast<MainguiWindow*>(qwid))->getActiveProject()) {
    Core_I& c = CoreFactory::getCore_I(); 
    QString qs = Projectname->text();
    FilterKeywords* fk;
    fk = new FilterKeywords();
    qs = fk->RemoveBlanks(qs);
    qs = fk->FilterSpecialChars(qs);
    qs = fk->FilterHDLKeywords(qs);
    qs = fk->FilterBusChars(qs);
    string name = QStrToStr(qs);
    c.projectName(name);
    c.addFsm();
    Fsm_I& f = c.getCurrentFsm();
    qs = FSMname->text();
    qs = fk->RemoveBlanks(qs);
    qs = fk->FilterSpecialChars(qs);
    qs = fk->FilterHDLKeywords(qs);
    qs = fk->FilterBusChars(qs);
    name = QStrToStr(qs);
    f.fsmName(name);
    (dynamic_cast<MainguiWindow*>(qwid))->setcurrentfsmid(f.getFsmID());
    (dynamic_cast<MainguiWindow*>(qwid))->setcurrenthierarchylevel(0);
    (dynamic_cast<MainguiWindow*>(qwid))->setActiveProject(true);
    (dynamic_cast<MainguiWindow*>(qwid))->activatepmode();  
    (dynamic_cast<MainguiWindow*>(qwid))->refresh();
    (dynamic_cast<MainguiWindow*>(qwid))->initFsm();
  }
  this->close();
}

string NewPro::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}

