/***********************************************************************
*                                                                      *
* (C) 2009, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <QtGui/QComboBox>
#include <QtGui/QSpinBox>
#include <QtGui/QLineEdit>

#include "colorbutton.h"
#include "statecombobox.h"

#include "outputdelegate.h"
#include "outputmodel.h"
#include "outputwidget.h"
#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

#include <iostream>

using namespace std;

OutputDelegate::OutputDelegate(QObject* parent) : QStyledItemDelegate(parent), colorEdited(false) {
    type=0; propid=0;
}

OutputDelegate::~OutputDelegate() {

}

void OutputDelegate::paint(QPainter* painter,const QStyleOptionViewItem& option, const QModelIndex& index) const {
    QStyledItemDelegate::paint(painter, option, index);
}

QSize OutputDelegate::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const {
    return QStyledItemDelegate::sizeHint(option, index);
}

void OutputDelegate::setEditorData(QWidget* editor,const QModelIndex& index) const {

    if (type==1) // state selector
    {
//        int idx = index.model()->data(index,Qt::EditRole).toInt();
//        QComboBox* box=static_cast<QComboBox*>(editor);
//        box->setCurrentIndex(idx);
        QStyledItemDelegate::setEditorData(editor, index);
    }
    else { // all other properties
        QStyledItemDelegate::setEditorData(editor, index);
    }
}
    //    if (index.row()==4 && type==1) // state color selector
//    {
//        unsigned int rgb = (index.model()->data(index,Qt::EditRole)).value<QColor>().rgb();
//        ColorButton* b=static_cast<ColorButton*>(editor);
//        b->setColor(rgb);
//    }
//    else if (index.row()==3 && type==3) // Link color selector
//    {
//        unsigned int rgb = (index.model()->data(index,Qt::EditRole)).value<QColor>().rgb();
//        ColorButton* b=static_cast<ColorButton*>(editor);
//        b->setColor(rgb);
//    }
//    else if ( (index.row()==4 && type==2) || // transition default selector
//              (index.row()==2 && type==1) )
//    {
//        int idx = index.model()->data(index,Qt::EditRole).toInt();
//        QComboBox* box=static_cast<QComboBox*>(editor);
//        box->setCurrentIndex(idx);
//    }
//    else if((index.row()==2 && type==2) || (index.row()==3 && type==2) || (index.row()==2 && type==3) || (index.row()==2 && type==4)) {
//        StateComboBox *box=static_cast<StateComboBox*>(editor);
//        int id = index.model()->data(index,Qt::EditRole).toInt();
//        int idx=box->findData ( id);
//        box->setCurrentIndex(idx);
//    }
//    else { // all other properties
//        QStyledItemDelegate::setEditorData(editor, index);
//    }


void OutputDelegate::setParams(int status, int id) {
    type = status;
    propid = id;
}


QWidget* OutputDelegate::createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index)  const {
    if ( type==1) //state color editor
    { //combobox editors
//        StateComboBox* w=new StateComboBox(parent,true);
//        w->installEventFilter(const_cast<OutputDelegate*>(this));
//        return w;
        return QStyledItemDelegate::createEditor(parent, option, index);
    }
    else
    { //even lines, leave default color
        return QStyledItemDelegate::createEditor(parent, option, index);
    }
}
//    if (index.row()==4 && type==1) //state color editor
//    {
//        ColorButton *b=new ColorButton(parent,QColor());
//        return b;
//    }
//    else if (index.row()==3 && type==3) // Link color editor
//    {
//        ColorButton *b=new ColorButton(parent,QColor());
//        return b;
//    }
//    else if((index.row()==2 && type==2) || (index.row()==3 && type==2) || (index.row()==2 && type==3) || (index.row()==2 && type==4))
//    { //combobox editors
//        StateComboBox* w=new StateComboBox(parent,true);
//        w->installEventFilter(const_cast<OutputDelegate*>(this));
//        return w;
//    }
//    else  if((index.row()%2) == 0)
//    { //even lines, leave default color
//        return QStyledItemDelegate::createEditor(parent, option, index);
//    }
//    else
//    { //odd lines ->paint gray
//        QWidget* w = QStyledItemDelegate::createEditor(parent, option, index);
//        QPalette p(w->palette());
//        p.setBrush(QPalette::Base, QBrush(QColor(221,223,228,255) ,Qt::SolidPattern));
//        w->setPalette(p);
//        return w;
//    }



void OutputDelegate::setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const {

 if (type==1) //state
    {

//        QComboBox *box=static_cast<QComboBox*>(editor);
//        if (box->currentIndex()==0){
//            cout<<"delegate set data...to false"<<endl;
//            const_cast<QAbstractItemModel*>(index.model())->setData(index,false,Qt::EditRole);}
//        else{
//            cout<<"delegate set data...to true"<<endl;
//            const_cast<QAbstractItemModel*>(index.model())->setData(index,true,Qt::EditRole);
//        }
        QStyledItemDelegate::setModelData(editor, model, index);
    }
    else
        QStyledItemDelegate::setModelData(editor, model, index);

}
//    if (index.row()==4 && type==1) //state color editor
//    {
//        ColorButton *b=static_cast<ColorButton*> (editor);
//        const_cast<QAbstractItemModel*>(index.model())->setData(index,b->getColor(),Qt::EditRole);
//    }
//    else if (index.row()==3 && type==3) // Link color editor
//    {
//        ColorButton *b=static_cast<ColorButton*> (editor);
//        const_cast<QAbstractItemModel*>(index.model())->setData(index,b->getColor(),Qt::EditRole);
//    }
//    else if ( (index.row()==4 && type==2)  ||// transition default selector
//              (index.row()==2 && type==1) )
//    {
//        QComboBox *box=static_cast<QComboBox*>(editor);
//        if (box->currentIndex()==0){
//            cout<<"delegate set data...to false"<<endl;
//            const_cast<QAbstractItemModel*>(index.model())->setData(index,false,Qt::EditRole);}
//        else{
//            cout<<"delegate set data...to true"<<endl;
//            const_cast<QAbstractItemModel*>(index.model())->setData(index,true,Qt::EditRole);
//        }
//    }
//    else if((index.row()==2 && type==2) || (index.row()==3 && type==2) || (index.row()==2 && type==3) || (index.row()==2 && type==4))
//    { //combobox editors
//        StateComboBox *box=static_cast<StateComboBox*>(editor);
//        QString qs = box->currentText();
//        FilterKeywords* fk;
//        fk = new FilterKeywords();
//        qs = fk->RemoveBlanks(qs);
//        qs = fk->FilterSpecialChars(qs);
//        qs = fk->FilterHDLKeywords(qs);
//        qs = fk->FilterBusChars(qs);
//        const_cast<QAbstractItemModel*>(index.model())->setData(index,qs,Qt::EditRole);
//    }
//    else
//        QStyledItemDelegate::setModelData(editor, model, index);



