/***********************************************************************
*                                                                      *
* (C) 2009, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <QtGui/QMenu>
#include <QtGui/QContextMenuEvent>

#include "outputwidget.h"

OutputWidget::OutputWidget(QWidget* w) : QTreeView(w) {
  createActions();

}

void OutputWidget::setMainWidget(QWidget* w) {
    wid = w;
}

QWidget* OutputWidget::getMainWidget() {
    return wid;
}

void OutputWidget::contextMenuEvent(QContextMenuEvent* e) {
   QMenu contextMenu(this);
   
   //if(this->currentItem()) {
   if( this->indexAt(e->pos()).isValid()  ) {
     contextMenu.addAction(rename);
     contextMenu.addAction(outputup); 
     contextMenu.addAction(outputdown);
     contextMenu.addAction(deleteselectedoutput);
     contextMenu.addSeparator();
   }
   contextMenu.addAction(newoutput);
   contextMenu.addAction(deleteoutput);
   contextMenu.exec(e->globalPos());
   
}

void OutputWidget::createActions(){
 rename = new QAction(this);
 rename->setObjectName(QString::fromUtf8("rename"));
 rename->setEnabled(true);    
 rename->setText(QApplication::translate("OutputWidget", "Rename", 0, QApplication::UnicodeUTF8));
 newoutput = new QAction(this);
 newoutput->setObjectName(QString::fromUtf8("newOutput"));
 newoutput->setEnabled(true);    
 newoutput->setText(QApplication::translate("OutputWidget", "New Output", 0, QApplication::UnicodeUTF8));
 deleteoutput = new QAction(this);
 deleteoutput->setObjectName(QString::fromUtf8("deleteOutput"));
 deleteoutput->setEnabled(true);    
 deleteoutput->setText(QApplication::translate("OutputWidget", "Delete last Output", 0, QApplication::UnicodeUTF8));
 deleteselectedoutput = new QAction(this);
 deleteselectedoutput->setObjectName(QString::fromUtf8("deleteSelectedOutput"));
 deleteselectedoutput->setEnabled(true);    
 deleteselectedoutput->setText(QApplication::translate("OutputWidget", "Delete selected Output", 0, QApplication::UnicodeUTF8));
 outputup = new QAction(this);
 outputup->setObjectName(QString::fromUtf8("moveupOutput"));
 outputup->setEnabled(true);    
 outputup->setText(QApplication::translate("OutputWidget", "Move up", 0, QApplication::UnicodeUTF8));
 outputdown = new QAction(this);
 outputdown->setObjectName(QString::fromUtf8("movedownOutput"));
 outputdown->setEnabled(true);    
 outputdown->setText(QApplication::translate("OutputWidget", "Move down", 0, QApplication::UnicodeUTF8));
}
