/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#ifndef PROJECTTREEWIDGET_H_
#define PROJECTTREEWIDGET_H_

#include <QtGui/QTreeWidget>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <string>
#include <iostream>
#include <sstream>

using namespace std;

class ProjectTreeWidget :  public QTreeWidget {

 public:
  QAction* addfsm;
  QAction* newhierarchylevel;
  QAction* deletelevel;
  QAction* deletefsm;
  QAction* deleteproject;
  QAction* renameproject;
  QAction* renamefsm;

  ProjectTreeWidget(QWidget* w);

  void contextMenuEvent(QContextMenuEvent* e);
  void mouseDoubleClickEvent(QMouseEvent* e);
  void setQWidget(QWidget* w);

 private:
  QWidget* qw;

  void createActions();
  string itos(int i);
};


#endif
