/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#ifndef PROPERTIESDELEGATE_H_
#define PROPERTIESDELEGATE_H_

#include <QtGui/QStyledItemDelegate>
#include <string>
#include <iostream>

#include "filterkeywords.h"

using namespace std;

class PropertiesDelegate : public QStyledItemDelegate {
  Q_OBJECT;
 public:
  PropertiesDelegate(QObject* parent = 0);
  ~PropertiesDelegate();

  void setParams(int status, int id);
  void paint(QPainter* painter,const QStyleOptionViewItem& option, const QModelIndex& index) const;
  QSize sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const;
  void setEditorData(QWidget* editor,const QModelIndex& index) const;
  QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const;
  void setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const;
 protected:
  int type;
  int propid;
  void setEdit() {colorEdited=true;}
  bool colorEdited;
};


#endif
