/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <QtGui/QTreeWidget>

#include "renamefsm.h"

#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"


RenameFsm::RenameFsm(QWidget* qw) : QDialog(qw) {
  w = qw;
  setupUi(this); 
  label->setText("Change FSM-name  :"); 
  this->setObjectName(QString::fromUtf8("FsmName"));
  this->setWindowTitle(QApplication::translate("RenameFsm", "Fsmname", 0, QApplication::UnicodeUTF8));
  Core_I& c = CoreFactory::getCore_I(); 
  Fsm_I& fs = c.getCurrentFsm();
  idold = fs.getFsmID();
  QString qs;
  string str; 
  if ((dynamic_cast<MainguiWindow*>(w))->projecttree->currentIndex().isValid()) {
    qs = (dynamic_cast<MainguiWindow*>(w))->projecttree->currentItem()->text(0);
    str = QStrToStr(qs); 
    if((strncmp(str.c_str(),"level",5)) == 0) {
      qs = (dynamic_cast<MainguiWindow*>(w))->projecttree->currentItem()->parent()->text(0);
      str = QStrToStr(qs);
    }
 
  bool found = false;
  if(strcmp(str.c_str(),c.getProjectName().c_str()) == 0) {
    string s = fs.getFsmName();
    QString qs = QString::fromStdString(s);
    id = idold;
  } else {
    if(c.getFirstFsm()) {
      do {
	Fsm_I& f = c.getCurrentFsm();
	if(strcmp(str.c_str(),f.getFsmName().c_str()) == 0) {
	  found = true;
	  id = f.getFsmID();
	}
      } while (c.getNextFsm() && !found);
    }
    if(!found) {
      QTreeWidgetItem* wit = (dynamic_cast<MainguiWindow*>(w))->projecttree->currentItem()->parent();
      QString qstr = wit->text(0);
      string stri = QStrToStr(qstr);
      found = false;
      if(c.getFirstFsm()) {
	do {
	  Fsm_I& f = c.getCurrentFsm();
	  if(strcmp(stri.c_str(),f.getFsmName().c_str()) == 0) {
	    found = true;
	    id = f.getFsmID();
	  }
	} while (c.getNextFsm() && !found);
      }   
    }
  } 
  } else {
    qs = QString::fromStdString(fs.getFsmName());
    id = idold;
  }
  lineEditInput->setText(qs);
  c.getFsm(idold);
}
 
string RenameFsm::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}


void RenameFsm::accept() {  
  if(idold != id) {
    (dynamic_cast<MainguiWindow*>(w))->setcurrentnumberofhlevels(0);
    (dynamic_cast<MainguiWindow*>(w))->setcurrenthierarchylevel(0);
  }
  QString qs = lineEditInput->text();
  FilterKeywords* fk;
  fk = new FilterKeywords();
  qs = fk->RemoveBlanks(qs);
  qs = fk->FilterSpecialChars(qs);
  //qs = fk->FilterHDLKeywords(qs);
  qs = fk->FilterBusChars(qs);
  string name = QStrToStr(qs);
  Core_I& c = CoreFactory::getCore_I();
  Fsm_I& f = c.getFsm(id); 
  f.fsmName(name);
  (dynamic_cast<MainguiWindow*>(w))->setcurrentfsmid((dynamic_cast<MainguiWindow*>(w))->getcurrentfsmid());
  (dynamic_cast<MainguiWindow*>(w))->refresh();
  this->done(0);
}
