/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "renameoutput.h"

#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"


RenameOutput::RenameOutput(QWidget* qw) : QDialog(qw) {
  w = qw;
  setupUi(this); 
  //QTreeWidgetItem* it = (dynamic_cast<MainguiWindow*>(w))->listofoutputs->currentItem();
  //index = (dynamic_cast<MainguiWindow*>(w))->listofoutputs->indexOfTopLevelItem(it);
  Core_I& c = CoreFactory::getCore_I();
  Fsm_I& f = c.getCurrentFsm();
  index = (dynamic_cast<MainguiWindow*>(w))->outputeditorwidget->currentIndex().row();
  //QString st = (dynamic_cast<MainguiWindow*>(w))->outputeditorwidget->currentIndex().data( Qt::DisplayRole).toString();
  string st = f.getOutputName(index);
  QString qs = QString ( st.c_str() );
  //lineEditOutput->setText(it->text(0));
  lineEditOutput->setText(qs);
}
 
string RenameOutput::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}


void RenameOutput::accept() {  
  QString qs = lineEditOutput->text();
  FilterKeywords* fk;
  fk = new FilterKeywords();
  qs = fk->RemoveBlanks(qs);
  qs = fk->FilterSpecialChars(qs);
  qs = fk->FilterHDLKeywords(qs);
  qs = fk->FilterBusChars(qs);
  string name = QStrToStr(qs);
  Core_I& c = CoreFactory::getCore_I();  
  Fsm_I& f = c.getCurrentFsm();
  f.outputName(index, name);
  //(dynamic_cast<MainguiWindow*>(w))->listofoutputs->currentItem()->setText(0,qs);
  dynamic_cast<MainguiWindow*>(w)->outpmodel->rowsChanged();

  this->done(0);
}
