/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "renameproject.h"

#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"


RenameProject::RenameProject(QWidget* qw) : QDialog(qw) {
  w = qw;
  setupUi(this); 
  label->setText("Change projectname :");
  this->setObjectName(QString::fromUtf8("projectname"));
  this->setWindowTitle(QApplication::translate("RenameProject", "Projectname", 0, QApplication::UnicodeUTF8));
  Core_I& c = CoreFactory::getCore_I(); 
  string s = c.getProjectName();
  QString qs = QString::fromStdString(s);
  lineEditInput->setText(qs);
}
 
string RenameProject::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}


void RenameProject::accept() {  
  QString qs = lineEditInput->text();
  FilterKeywords* fk;
  fk = new FilterKeywords();
  qs = fk->RemoveBlanks(qs);
  qs = fk->FilterSpecialChars(qs);
  qs = fk->FilterHDLKeywords(qs);
  qs = fk->FilterBusChars(qs);
  string name = QStrToStr(qs);
  Core_I& c = CoreFactory::getCore_I();  
  c.projectName(name);
  (dynamic_cast<MainguiWindow*>(w))->refreshProjectTree();
  this->done(0);
}
