/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <QtGui/QMenu>
#include <QtGui/QContextMenuEvent>

#include "tablestate.h"

#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

TableState::TableState(QWidget* w) : QTreeView(w) {
 createActions();
}

void TableState::contextMenuEvent(QContextMenuEvent* e) {
  Core_I& core = CoreFactory::getCore_I();  
  Fsm_I& fsm = core.getCurrentFsm();
  QMenu contextMenu(this);
  contextMenu.addAction(addState);
  int row = 0;
  if(fsm.getFirstState()) {
    do {
      if(row == currentIndex().row()) { 
	contextMenu.addAction(deleteState);
      } 
      row++;
    } while (fsm.getNextState());
  } 
  contextMenu.exec(e->globalPos());
}

void TableState::createActions() {
  addState = new QAction(this);
  addState->setObjectName(QString::fromUtf8("addstate"));
  addState->setEnabled(true);    
  addState->setText(QApplication::translate("TableState", "Add State", 0, QApplication::UnicodeUTF8));
  deleteState = new QAction(this);
  deleteState->setObjectName(QString::fromUtf8("deletestate"));
  deleteState->setEnabled(true);    
  deleteState->setText(QApplication::translate("TableState", "Delete State", 0, QApplication::UnicodeUTF8));
}
