/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include <cstdlib>
#include <stdio.h>
#include <string>
#include <iostream>
#include <fstream>
#include <limits.h>

#include <QtCore/QDir>
#include <QtCore/QString>

using namespace std;

/* function to show binary .....not needed
   void print_char_as_binary(char ch) {
   int i = CHAR_BIT;
   while (i > 0) {
   --i;
   cout << (ch&(1<<i)?'1':'0');
   }
   }
*/

int main(int argc, char** argv) {


  QDir dir = QDir::home();
  string homepath = dir.path().toStdString();
  string name;

  //// gifs ////

  /// FSMDesignerlogoicon.gif ///

char bin_data_logo[] = /* 1052 */
{0x47,0x49,0x46,0x38,0x39,0x61,0x26,0x00,0x1A,0x00,0xC6,0x51,0x00,0x91,0x91
,0x91,0x97,0x97,0x97,0x99,0x99,0x99,0xA0,0xA0,0xA0,0xA2,0xA2,0xA2,0xA7,0xA7
,0xA7,0xA8,0xA8,0xA8,0xAE,0xAE,0xAE,0xB1,0xB1,0xB1,0xB6,0xB6,0xB6,0xB7,0xB7
,0xB7,0xB8,0xB8,0xB8,0xB9,0xB9,0xB9,0xBA,0xBA,0xBA,0xBB,0xBB,0xBB,0xBD,0xBD
,0xBD,0xBE,0xBE,0xBE,0xBF,0xBF,0xBF,0xC0,0xC0,0xC0,0xC1,0xC1,0xC1,0xC2,0xC2
,0xC2,0xC3,0xC3,0xC3,0xC4,0xC4,0xC4,0xC5,0xC5,0xC5,0xC6,0xC6,0xC6,0xC7,0xC7
,0xC7,0xC8,0xC8,0xC8,0xC9,0xC9,0xC9,0xCA,0xCA,0xCA,0xCB,0xCB,0xCB,0xCC,0xCC
,0xCC,0xCD,0xCD,0xCD,0xCE,0xCE,0xCE,0xCF,0xCF,0xCF,0xD0,0xD0,0xD0,0xD1,0xD1
,0xD1,0xD2,0xD2,0xD2,0xD3,0xD3,0xD3,0xD4,0xD4,0xD4,0xD5,0xD5,0xD5,0xD6,0xD6
,0xD6,0xD7,0xD7,0xD7,0xD8,0xD8,0xD8,0xD9,0xD9,0xD9,0xDA,0xDA,0xDA,0xDB,0xDB
,0xDB,0xDC,0xDC,0xDC,0xDD,0xDD,0xDD,0xDE,0xDE,0xDE,0xDF,0xDF,0xDF,0xE0,0xE0
,0xE0,0xE1,0xE1,0xE1,0xE2,0xE2,0xE2,0xE3,0xE3,0xE3,0xE4,0xE4,0xE4,0xE5,0xE5
,0xE5,0xE6,0xE6,0xE6,0xE7,0xE7,0xE7,0xE8,0xE8,0xE8,0xE9,0xE9,0xE9,0xEA,0xEA
,0xEA,0xEB,0xEB,0xEB,0xEC,0xEC,0xEC,0xED,0xED,0xED,0xEE,0xEE,0xEE,0xEF,0xEF
,0xEF,0xF0,0xF0,0xF0,0xF1,0xF1,0xF1,0xF2,0xF2,0xF2,0xF3,0xF3,0xF3,0xF4,0xF4
,0xF4,0xF5,0xF5,0xF5,0xF6,0xF6,0xF6,0xF7,0xF7,0xF7,0xF8,0xF8,0xF8,0xF9,0xF9
,0xF9,0xFA,0xFA,0xFA,0xFB,0xFB,0xFB,0xFC,0xFC,0xFC,0xFD,0xFD,0xFD,0xFE,0xFE
,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x21,0xFE,0x15,0x43,0x72,0x65,0x61,0x74
,0x65,0x64,0x20,0x77,0x69,0x74,0x68,0x20,0x54,0x68,0x65,0x20,0x47,0x49,0x4D
,0x50,0x00,0x2C,0x00,0x00,0x00,0x00,0x26,0x00,0x1A,0x00,0x00,0x07,0xFE,0x80
,0x51,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x50,0x4B
,0x48,0x91,0x91,0x4A,0x4F,0x8D,0x8E,0x46,0x42,0x45,0x48,0x49,0x4A,0x9D,0x49
,0x47,0x45,0x44,0x45,0x4D,0x96,0x87,0x50,0x46,0x41,0x47,0x4B,0x4C,0x95,0x82
,0x4C,0x34,0x33,0x32,0x32,0x43,0x42,0x43,0x50,0xA5,0x83,0x4D,0x40,0x47,0x4E
,0xB7,0x85,0x2D,0x45,0x45,0x26,0x0B,0x3A,0x4F,0x4A,0x3F,0xA4,0x88,0x4F,0x4E
,0x4F,0xAD,0x51,0x4A,0x40,0x4A,0xA6,0x47,0x25,0x43,0x17,0x25,0x40,0x4E,0x82
,0x4F,0x46,0xC9,0x85,0x4C,0x44,0x42,0xE2,0x4B,0x51,0x4E,0x44,0x49,0x86,0x4E
,0x46,0x3D,0x22,0x2B,0x3F,0x1D,0x47,0x4C,0x45,0xDA,0xCF,0x40,0xDE,0x83,0x41
,0xD2,0x51,0x4D,0x3F,0x46,0x49,0x45,0x84,0xA0,0x20,0x01,0xE2,0x23,0x06,0x86
,0x20,0x25,0x8E,0xBC,0x08,0x02,0x84,0xC3,0x10,0x41,0x4D,0x74,0x08,0x31,0x84
,0x84,0x50,0x12,0x18,0x46,0xF4,0x35,0xE9,0xF1,0xC2,0x02,0x85,0x1B,0x3C,0x56
,0x0C,0x99,0xA1,0x63,0x48,0x10,0x1D,0x0F,0x26,0x32,0xE1,0x91,0xE3,0x06,0x0E
,0x7D,0x82,0x7C,0x41,0x01,0x12,0xA3,0x03,0x0D,0x23,0x43,0x72,0xD8,0x90,0x61
,0x00,0xC0,0x80,0x12,0x31,0x62,0xDC,0x90,0xF1,0x42,0x85,0x08,0x0C,0x28,0x96
,0x3C,0x91,0x41,0x02,0x44,0x05,0x15,0x2F,0xEE,0x09,0xBA,0x41,0x83,0x44,0x02
,0x13,0x37,0x46,0xCC,0x20,0xF2,0xE2,0xC0,0x82,0x0D,0x2D,0x6A,0xF4,0x30,0x42
,0xA4,0xC6,0x88,0x0F,0x2F,0xD0,0x31,0x19,0x91,0x80,0x44,0x87,0xAF,0xFE,0x3C
,0x06,0x91,0x03,0x52,0xA3,0x2D,0x09,0x09,0x20,0x5A,0x80,0xB0,0x80,0xA2,0x05
,0x0D,0x1D,0xBC,0x2A,0x41,0x71,0xC2,0x84,0x89,0xB6,0x22,0x2B,0x68,0x28,0xC0
,0xB1,0x63,0x84,0x0A,0x08,0x40,0x2A,0x12,0x69,0x52,0x43,0x86,0x03,0x1E,0x31
,0x56,0x94,0x60,0x91,0xC2,0xAF,0x2D,0x43,0x4F,0x98,0x18,0x89,0x61,0x82,0x41
,0x0D,0x17,0x20,0x74,0xEC,0x50,0x71,0x22,0x04,0x94,0x22,0x42,0x96,0x08,0x61
,0xE1,0x41,0x84,0x8F,0x15,0x27,0x26,0x5C,0x68,0x81,0xE4,0x51,0x92,0x56,0x8F
,0x8A,0xE0,0xF0,0xB0,0xA0,0xC0,0x88,0x14,0x2E,0x48,0xB4,0x6B,0x31,0xE2,0x42
,0x8C,0x28,0x50,0x8E,0x40,0x27,0x82,0x41,0x83,0x5F,0x10,0x17,0x58,0x2C,0xE1
,0xE7,0x23,0x87,0x8E,0x1F,0x42,0x70,0xD4,0x68,0x60,0x40,0x40,0x00,0x02,0x11
,0x34,0x9C,0xC8,0x10,0x81,0xC2,0x86,0x0D,0x2A,0xF4,0xA1,0x83,0xEE,0xC2,0xC3
,0x87,0x11,0x21,0x4C,0xD8,0xF2,0xB1,0x63,0x88,0x91,0x19,0x25,0x88,0x40,0x02
,0x0D,0x04,0x10,0x80,0xC0,0x53,0x34,0xF0,0x40,0x90,0x0D,0x21,0xA4,0x80,0x83
,0x11,0xBE,0xCC,0x57,0x4E,0x0F,0x2C,0x90,0x80,0xC3,0x11,0x4F,0x04,0x91,0x01
,0x08,0x1D,0x8C,0x30,0x44,0x0C,0x2F,0xDC,0xF0,0x42,0x08,0x2B,0xCC,0xB0,0x0B
,0x25,0xD0,0x21,0xD1,0xC3,0x0D,0x12,0x9A,0x53,0x48,0x12,0x32,0xC4,0x15,0x45
,0x12,0x31,0xC0,0x80,0xC3,0x0C,0x7F,0x01,0xA1,0x83,0x0C,0x3A,0x20,0xA1,0x14
,0x21,0x4D,0x04,0xD1,0x04,0x2A,0x49,0x30,0x81,0x44,0x10,0x46,0x18,0x6A,0x02
,0xCD,0x20,0xCD,0x38,0xC1,0x43,0x0D,0x34,0x40,0x89,0x04,0x3D,0x01,0x0D,0x41
,0x04,0x74,0x4D,0x80,0x92,0x44,0x13,0xBE,0x04,0xA4,0x04,0x12,0x82,0x51,0x45
,0xC4,0x10,0x29,0xBC,0x40,0x0E,0x68,0x44,0x04,0x81,0x8B,0x40,0x45,0x28,0xD1
,0x04,0x06,0x27,0xA4,0x60,0x01,0x09,0x3C,0x48,0xF5,0x84,0x6C,0x00,0xE1,0x22
,0x88,0x12,0xFE,0x05,0xD1,0x81,0x07,0x2A,0xEC,0x70,0xE6,0x60,0x5F,0x16,0x31
,0xC4,0x99,0x7A,0x0E,0x92,0x84,0x11,0x92,0x34,0x7A,0xC4,0x11,0x46,0xB4,0xD9
,0x65,0xA2,0x01,0x35,0xB1,0x44,0x27,0x98,0x72,0x49,0xE9,0xA6,0x96,0x04,0x02
,0x00,0x3B};

  name = homepath + "/.fsmdesigner4/FSMDesignerlogoicon.gif";
  const char*const filenamelogo = name.c_str();
  ofstream outlogo(filenamelogo, ios_base::binary); 
  
  if(outlogo.is_open()) {
    for(int i=0; i < 1052; i++){
      outlogo << bin_data_logo[i];
    }
    outlogo.close();
  }

  /// stepper.gif ///

char bin_data_stepper[] =/* 109 */
{0x47,0x49,0x46,0x38,0x39,0x61,0x1A,0x00,0x1A,0x00,0x80,0x02,0x00,0x00,0x00
,0x00,0xDF,0xDF,0xDF,0x21,0xFE,0x15,0x43,0x72,0x65,0x61,0x74,0x65,0x64,0x20
,0x77,0x69,0x74,0x68,0x20,0x54,0x68,0x65,0x20,0x47,0x49,0x4D,0x50,0x00,0x2C
,0x00,0x00,0x00,0x00,0x1A,0x00,0x1A,0x00,0x00,0x02,0x33,0x8C,0x8F,0xA9,0xCB
,0x6D,0x00,0xA1,0x9B,0x60,0xDA,0x77,0x5B,0x94,0x59,0xD5,0xAE,0x81,0xDE,0x26
,0x22,0x5F,0x99,0x9C,0xE8,0xA6,0x8A,0x2D,0x1A,0xBC,0x20,0x0B,0xC7,0xB5,0x79
,0xD3,0xB0,0x5C,0xF2,0x99,0xBE,0xBA,0x1D,0x7C,0x17,0x60,0x4F,0x88,0x41,0x2A
,0x03,0x05,0x00,0x3B};

  name = homepath + "/.fsmdesigner4/stepper.gif";
  const char*const filenamestepper = name.c_str();
  ofstream outstepper(filenamestepper, ios_base::binary); 
  
  if(outstepper.is_open()) {
    for(int i=0; i < 109; i++){
      outstepper << bin_data_stepper[i];
    }
    outstepper.close();
  }

  /// next.gif ///

char bin_data_next[] = /* 114 */
{0x47,0x49,0x46,0x38,0x39,0x61,0x1A,0x00,0x1A,0x00,0x80,0x02,0x00,0x7F,0xAA
,0xCF,0xDF,0xDF,0xDF,0x21,0xFE,0x15,0x43,0x72,0x65,0x61,0x74,0x65,0x64,0x20
,0x77,0x69,0x74,0x68,0x20,0x54,0x68,0x65,0x20,0x47,0x49,0x4D,0x50,0x00,0x2C
,0x00,0x00,0x00,0x00,0x1A,0x00,0x1A,0x00,0x00,0x02,0x38,0x8C,0x8F,0xA9,0xCB
,0xED,0x0F,0xA3,0x94,0x60,0x3A,0x50,0xED,0xC2,0x59,0x23,0xDE,0x79,0x01,0x18
,0x6A,0x64,0x99,0x9C,0x2A,0xD8,0xAC,0x2E,0x6A,0xBC,0xEE,0x26,0xAF,0x4A,0xAD
,0xD2,0x38,0xC7,0xEC,0xBC,0x77,0x12,0x8D,0x58,0x42,0x62,0x11,0x23,0x3C,0x20
,0x93,0x31,0xA6,0xF3,0x29,0x2A,0x00,0x00,0x3B};
 
  name = homepath + "/.fsmdesigner4/next.gif";
  const char*const filenamenext = name.c_str();
  ofstream outnext(filenamenext, ios_base::binary); 
  
  if(outnext.is_open()) {
    for(int i=0; i < 114; i++){
      outnext << bin_data_next[i];
      //print_char_as_binary(bin_data_next[i]);
    }
    outnext.close();
  }

  /// next_edge.gif ///

char bin_data_nedge[] = /* 123 */
{0x47,0x49,0x46,0x38,0x39,0x61,0x1A,0x00,0x1A,0x00,0xA1,0x03,0x00,0x00,0x00
,0x00,0x64,0xCF,0x26,0xDF,0xDF,0xDF,0xFF,0xFF,0xFF,0x21,0xFE,0x15,0x43,0x72
,0x65,0x61,0x74,0x65,0x64,0x20,0x77,0x69,0x74,0x68,0x20,0x54,0x68,0x65,0x20
,0x47,0x49,0x4D,0x50,0x00,0x2C,0x00,0x00,0x00,0x00,0x1A,0x00,0x1A,0x00,0x00
,0x02,0x3B,0x94,0x8F,0xA9,0xCB,0x19,0x0D,0x55,0x78,0xB1,0x4E,0x5A,0xDB,0xC5
,0x59,0x6E,0xBB,0x85,0x61,0x24,0x96,0x17,0x64,0xA6,0x5A,0x6A,0x32,0x6C,0xB9
,0xBE,0x67,0x2C,0x77,0xDE,0x6C,0x23,0x5F,0xEE,0x4C,0xBC,0xF7,0x93,0x04,0x87
,0xC4,0xA2,0xB1,0x08,0x48,0x2A,0x97,0x00,0x5B,0xF3,0xF8,0xCC,0x31,0x95,0x95
,0x02,0x00,0x3B};

  name = homepath + "/.fsmdesigner4/next_edge.gif";
  const char*const filenamenedge = name.c_str();
  ofstream outnedge(filenamenedge, ios_base::binary); 
  
  if(outnedge.is_open()) {
    for(int i=0; i < 123; i++){
      outnedge << bin_data_nedge[i];
    }
    outnedge.close();
  }

  /// previous.gif ///

char bin_data_previous[] =  /* 114 */
{0x47,0x49,0x46,0x38,0x39,0x61,0x1A,0x00,0x1A,0x00,0x80,0x02,0x00,0x47,0xAA
,0xCF,0xDF,0xDF,0xDF,0x21,0xFE,0x15,0x43,0x72,0x65,0x61,0x74,0x65,0x64,0x20
,0x77,0x69,0x74,0x68,0x20,0x54,0x68,0x65,0x20,0x47,0x49,0x4D,0x50,0x00,0x2C
,0x00,0x00,0x00,0x00,0x1A,0x00,0x1A,0x00,0x00,0x02,0x38,0x8C,0x8F,0xA9,0xCB
,0xED,0x0F,0xA3,0x6C,0x60,0xD2,0x6A,0x15,0xD8,0x39,0x6D,0xDE,0x19,0x1F,0xD8
,0x8D,0xA4,0x65,0xA6,0x29,0xA3,0xB6,0xDF,0xE2,0xC6,0x5A,0xEC,0xC2,0xB4,0xCA
,0xDE,0xE6,0xA5,0x9F,0xF3,0x18,0x12,0x01,0x83,0x81,0x21,0xF1,0x45,0x14,0x26
,0x0F,0x98,0xA5,0xF3,0x19,0x2A,0x00,0x00,0x3B};

  name = homepath + "/.fsmdesigner4/previous.gif";
  const char*const filenameprevious = name.c_str();
  ofstream outprevious(filenameprevious, ios_base::binary); 

  if(outprevious.is_open()) {
    for(int i=0; i < 114; i++){
      outprevious << bin_data_previous[i];
    }
    outprevious.close();
  }

  /// previous_edge.gif ///

char bin_data_pedge[] = /* 126 */
{0x47,0x49,0x46,0x38,0x39,0x61,0x1A,0x00,0x1A,0x00,0xA1,0x03,0x00,0x00,0x00
,0x00,0x64,0xCF,0x36,0xDF,0xDF,0xDF,0xFF,0xFF,0xFF,0x21,0xFE,0x15,0x43,0x72
,0x65,0x61,0x74,0x65,0x64,0x20,0x77,0x69,0x74,0x68,0x20,0x54,0x68,0x65,0x20
,0x47,0x49,0x4D,0x50,0x00,0x2C,0x00,0x00,0x00,0x00,0x1A,0x00,0x1A,0x00,0x00
,0x02,0x3E,0x94,0x8F,0xA9,0xCB,0xC1,0xBF,0x82,0x83,0x54,0xC8,0x59,0xDB,0xCD
,0x7A,0xF3,0x74,0x85,0xA2,0xD7,0x8D,0xE6,0x63,0xA6,0x52,0xA9,0x8A,0x68,0x3B
,0x42,0xB0,0x2B,0xCF,0x2B,0x45,0x7F,0x20,0xA9,0x23,0x7C,0x7F,0xB8,0x01,0x41
,0xC3,0xA2,0xF1,0x88,0xD4,0x01,0x96,0xCC,0x26,0x20,0x29,0x78,0x26,0xA5,0x48
,0x67,0x33,0x51,0x00,0x00,0x3B};

  name = homepath + "/.fsmdesigner4/previous_edge.gif";
  const char*const filenamepedge = name.c_str();
  ofstream outpedge(filenamepedge, ios_base::binary); 
  
  if(outpedge.is_open()) {
    for(int i=0; i < 126; i++){
      outpedge << bin_data_pedge[i];
    }
    outpedge.close();
  }

/// current.gif ///

char bin_data_current[] = /* 138 */
{0x47,0x49,0x46,0x38,0x39,0x61,0x1A,0x00,0x1A,0x00,0x80,0x02,0x00,0x00,0x00
,0x00,0xDF,0xDF,0xDF,0x21,0xFE,0x15,0x43,0x72,0x65,0x61,0x74,0x65,0x64,0x20
,0x77,0x69,0x74,0x68,0x20,0x54,0x68,0x65,0x20,0x47,0x49,0x4D,0x50,0x00,0x2C
,0x00,0x00,0x00,0x00,0x1A,0x00,0x1A,0x00,0x00,0x02,0x50,0x8C,0x8F,0xA9,0xCB
,0xED,0x0F,0x1B,0x98,0x14,0x44,0x34,0x57,0x8E,0xD6,0x75,0x8F,0x55,0x18,0x68
,0x6C,0x87,0xF9,0x25,0xDF,0x8A,0x9E,0x5A,0xE9,0xC2,0x72,0x3A,0xC7,0x76,0x47
,0xE3,0x72,0xB0,0xD6,0x23,0x5F,0xD3,0x01,0x87,0x31,0x21,0x51,0x98,0xDB,0x25
,0x7D,0xBF,0x9E,0x72,0xF7,0x3B,0xB6,0xA0,0x51,0x53,0xC9,0xC9,0x48,0x55,0xB4
,0x10,0x9A,0xC2,0x9B,0x05,0x5B,0x39,0x5B,0xF0,0xE5,0x8C,0x4E,0xAB,0xD7,0x8C
,0x02,0x00,0x3B};

  name = homepath + "/.fsmdesigner4/current.gif";
  const char*const filenamecurrent = name.c_str();
  ofstream outcurrent(filenamecurrent, ios_base::binary); 
  
  if(outcurrent.is_open()) {
    for(int i=0; i < 138; i++){
      outcurrent << bin_data_current[i];
    }
    outcurrent.close();
  }


  //// simvisonrc code ////

  name = homepath + "/.simvisionrc";
  const char*const filename = name.c_str();
  ofstream out(filename, ios_base::app); 
  
  if(out.is_open()) {
    out << endl << endl;
    out << "set w [waveform new]" << endl;
    out << "set tb [window toolbar create $w]" << endl;
    out << "set b [window toolbar component add $w $tb button -label fsmdesigner4_button]" << endl;
    out << "action configure $b -helptext \"This action opens the FSMDesigner4 in simulation mode.\"" << endl;
    out << "action configure $b -icon \"" << homepath << "/.fsmdesigner4/FSMDesignerlogoicon.gif\"" << endl;
    out << "action configure $b -command \"exec fsmdesigner4 -s\"" << endl; 
    out << "set b2 [window toolbar component add $w $tb button -label stepper_button]" << endl;
    out << "action configure $b2 -helptext \"Action to open a stepper for using FSMDesigner4 in simulation mode.\"" << endl;
    out << "action configure $b2 -icon \"" << homepath << "/.fsmdesigner4/stepper.gif\"" << endl;
    out << "action configure $b2 -command {cursor new -name fsmdesigner4sim -time 0" << endl;
    out << "exec mkfifo " << homepath <<"/.fsmdesigner4/fifotest " << endl;
    out << "toplevel .stepper " << endl;
    out << "label .stepper.l -text \"Step size: \" " << endl;
    out << "entry .stepper.e -width 20 -relief sunken -textvariable value"<< endl;
    out << "set value 0"<< endl;
    out << "pack .stepper.l .stepper.e"<< endl;
    out << "button .stepper.b -text \"Next step\" -command {set fid [open " << homepath << "/.fsmdesigner4/fifotest w+]" << endl; 
    out << "set str [cursor get -using fsmdesigner4sim -time]" << endl;
    out << "regsub \",\" $str \"\" str" << endl;
    out << "set len [string length $str]" << endl;
    out << "set ex [expr $len - 3]" << endl;
    out << "set valold [string range $str 0 $ex]" << endl;
    out << "set val [expr $valold + $value]" << endl;
    out << "cursor set -using fsmdesigner4sim -time $val" << endl;
    out << "set i [waveform find -using %n -name \"*inputvector*\" ]" << endl;
    out << "set ct [cursor get -using fsmdesigner4sim -time]" << endl;
    out << "set vi [waveform values -using %n -at $ct $i]" << endl;
    out << "set s [waveform find -using %n -name \"*current_state*\" ]" << endl;
    out << "set vs [waveform values -using %n -at $ct $s]" << endl;
    out << "set ns [waveform find -using %n -name \"*next_state*\" ]" << endl;
    out << "set vns [waveform values -using %n -at $ct $ns]" << endl;
    out << "puts -nonewline $fid \"$vi \"" << endl;
    out << "puts -nonewline $fid \"$vs \"" << endl;
    out << "puts -nonewline $fid \"$vns \"" << endl; 
    out << "puts $fid \"$ct \"" << endl; 
    out << "close $fid}" << endl;
    out << "button .stepper.b2 -text Close -command {cursor delete fsmdesigner4sim " << endl;
    out << "destroy .stepper }" << endl;
    out << "pack .stepper.b .stepper.b2 -side left}"<< endl;
    // new    
    out << "set b3 [window toolbar component add $w $tb button -label Previous_edge_button]"<< endl;
    out << "action configure $b3 -helptext \"Move simulation cursor to previous edge of selected signal.\" "<< endl; 
    out << "action configure $b3 -icon \"" << homepath << "/.fsmdesigner4/previous_edge.gif\" "<< endl;
    out << "action configure $b3 -command { set old [cursor get -using TimeA -time] "<< endl;
    out << "set new [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "cursor set -using TimeA -time $new "<< endl;
    out << "waveform xview moveto -prev edge "<< endl;
    out << "set new2 [cursor get -using TimeA -time] "<< endl;
    out << "cursor set -using fsmdesigner4sim -time $new2 "<< endl;
    out << "cursor set -using TimeA -time $old "<< endl;
    out << "set fid [open " << homepath << "/.fsmdesigner4/fifotest w+] "<< endl;
    out << "set i [waveform find -using %n -name \"*inputvector*\" ] "<< endl;
    out << "set ct [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "set vi [waveform values -using %n -at $ct $i] "<< endl;
    out << "set s [waveform find -using %n -name \"*current_state*\" ] "<< endl;
    out << "set vs [waveform values -using %n -at $ct $s] "<< endl;
    out << "set ns [waveform find -using %n -name \"*next_state*\" ] "<< endl;
    out << "set vns [waveform values -using %n -at $ct $ns ] "<< endl;
    out << "puts -nonewline $fid \"$vi \" "<< endl;
    out << "puts -nonewline $fid \"$vs \" "<< endl;
    out << "puts -nonewline $fid \"$vns \" "<< endl;
    out << "puts $fid \"$ct \" "<< endl;
    out << "close $fid } "<< endl;
    out << "set b4 [window toolbar component add $w $tb button -label Previous_step_button] "<< endl;
    out << "action configure $b4 -helptext \"Previous Step.\" "<< endl;
    out << "action configure $b4 -icon \"" << homepath << "/.fsmdesigner4/previous.gif\" "<< endl;
    out << "action configure $b4 -command { set fid [open " << homepath << "/.fsmdesigner4/fifotest w+] "<< endl;
    out << "set str [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "regsub \",\" $str \"\" str" << endl;
    out << "set len [string length $str] "<< endl;
    out << "set ex [expr $len - 3] "<< endl;
    out << "set valold [string range $str 0 $ex] "<< endl;
    out << "set val [expr $valold - $value] "<< endl;
    out << "cursor set -using fsmdesigner4sim -time $val "<< endl;
    out << "set i [waveform find -using %n -name \"*inputvector*\" ] "<< endl;
    out << "set ct [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "set vi [waveform values -using %n -at $ct $i] "<< endl;
    out << "set s [waveform find -using %n -name \"*current_state*\" ] "<< endl;
    out << "set vs [waveform values -using %n -at $ct $s] "<< endl;
    out << "set ns [waveform find -using %n -name \"*next_state*\" ] "<< endl;
    out << "set vns [waveform values -using %n -at $ct $ns] "<< endl;
    out << "puts -nonewline $fid \"$vi \" "<< endl;
    out << "puts -nonewline $fid \"$vs \" "<< endl;
    out << "puts -nonewline $fid \"$vns \" "<< endl;
    out << "puts $fid \"$ct \" "<< endl;
    out << "close $fid } "<< endl;
    out << "set b5 [window toolbar component add $w $tb button -label Current_button] "<< endl;
    out << "action configure $b5 -helptext \"Send current values to FSMDesigner4.\" "<< endl;
    out << "action configure $b5 -icon \"" << homepath << "/.fsmdesigner4/current.gif\" "<< endl;
    out << "action configure $b5 -command {set fid [open " << homepath << "/.fsmdesigner4/fifotest w+] "<< endl;
    out << "set i [waveform find -using %n -name \"*inputvector*\" ] "<< endl;
    out << "set ct [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "set vi [waveform values -using %n -at $ct $i] "<< endl;
    out << "set s [waveform find -using %n -name \"*current_state*\" ] "<< endl;
    out << "set vs [waveform values -using %n -at $ct $s] "<< endl;
    out << "set ns [waveform find -using %n -name \"*next_state*\" ] "<< endl;
    out << "set vns [waveform values -using %n -at $ct $ns] "<< endl;
    out << "puts -nonewline $fid \"$vi \" "<< endl;
    out << "puts -nonewline $fid \"$vs \" "<< endl;
    out << "puts -nonewline $fid \"$vns \" "<< endl;
    out << "puts $fid \"$ct \" "<< endl;
    out << "close $fid } "<< endl;
    out << "set b6 [window toolbar component add $w $tb button -label Next_step_button] "<< endl;
    out << "action configure $b6 -helptext \"Next Step\" "<< endl;
    out << "action configure $b6 -icon \"" << homepath << "/.fsmdesigner4/next.gif\" "<< endl;
    out << "action configure $b6 -command {set fid [open " << homepath << "/.fsmdesigner4/fifotest w+] "<< endl;
    out << "set str [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "regsub \",\" $str \"\" str "<< endl;
    out << "set len [string length $str] "<< endl;
    out << "set ex [expr $len - 3] "<< endl;
    out << "set valold [string range $str 0 $ex] "<< endl;
    out << "set val [expr $valold + $value] "<< endl;
    out << "cursor set -using fsmdesigner4sim -time $val"<< endl;
    out << "set i [waveform find -using %n -name \"*inputvector*\" ] "<< endl;
    out << "set ct [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "set vi [waveform values -using %n -at $ct $i] "<< endl;
    out << "set s [waveform find -using %n -name \"*current_state*\" ] "<< endl;
    out << "set vs [waveform values -using %n -at $ct $s] "<< endl;
    out << "set ns [waveform find -using %n -name \"*next_state*\" ] "<< endl;
    out << "set vns [waveform values -using %n -at $ct $ns] "<< endl;
    out << "puts -nonewline $fid \"$vi \" "<< endl;
    out << "puts -nonewline $fid \"$vs \" "<< endl;
    out << "puts -nonewline $fid \"$vns \" "<< endl;
    out << "puts $fid \"$ct \" "<< endl;
    out << "close $fid } "<< endl;
    out << "set b7 [window toolbar component add $w $tb button -label Next_edge_button] "<< endl;
    out << "action configure $b7 -helptext \"Move simulation cursor to next edge of selected signal.\" "<< endl;
    out << "action configure $b7 -icon \"" << homepath << "/.fsmdesigner4/next_edge.gif\" "<< endl;
    out << "action configure $b7 -command {set old [cursor get -using TimeA -time] "<< endl;
    out << "set new [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "cursor set -using TimeA -time $new "<< endl;
    out << "waveform xview moveto -next edge "<< endl;
    out << "set new2 [cursor get -using TimeA -time] "<< endl;
    out << "cursor set -using fsmdesigner4sim -time $new2 "<< endl;
    out << "cursor set -using TimeA -time $old "<< endl;
    out << "set fid [open " << homepath << "/.fsmdesigner4/fifotest w+] "<< endl;
    out << "set i [waveform find -using %n -name \"*inputvector*\" ] "<< endl;
    out << "set ct [cursor get -using fsmdesigner4sim -time] "<< endl;
    out << "set vi [waveform values -using %n -at $ct $i] "<< endl;
    out << "set s [waveform find -using %n -name \"*current_state*\" ] "<< endl;
    out << "set vs [waveform values -using %n -at $ct $s] "<< endl;
    out << "set ns [waveform find -using %n -name \"*next_state*\" ] "<< endl;
    out << "set vns [waveform values -using %n -at $ct $ns] "<< endl;
    out << "puts -nonewline $fid \"$vi \" "<< endl;
    out << "puts -nonewline $fid \"$vs \" "<< endl;
    out << "puts -nonewline $fid \"$vns \" "<< endl;
    out << "puts $fid \"$ct \" "<< endl;
    out << "close $fid } "<< endl;
    out << "rm " << homepath << "/.simvisionrc"<< endl;
    out.close();
  }
  return 0;
}

