/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "simthread.h"
#include "../gui/mainguiwindow.h"

#include <QtCore/QDir>
#include <QtCore/QString>

SimThread::SimThread(QWidget* w): QThread() {
  qw = w;
  a = "";
  b = "";
  c = "";
  d = "";
} 



void SimThread::run() {
    cout << "read_fifo test program" << endl;
    QDir dir = QDir::home();
    string name = dir.path().toStdString() + "/.fsmdesigner4/fifotest";
    const char*const filename = name.c_str();
    FILE* f=fopen(filename,"r");
    int fd=fileno(f);
    buffer=(char*)malloc(1024);
    
    while (true) {
      memset(buffer,0,1024);
      size=1024;
      result=getline(&buffer,&size,f);
      cout << "Received with result " << result << " : " << buffer << endl;
     
      //emit signal & send data to GUI window

      if(result > 0) {
	string s = buffer;
	a = "";
	int i = 0;
	int j = 0;
	a = s;
	s = strstr(a.c_str()," ");
	i = a.length();
	j = s.length();
	a.assign(a,0,i-j);
	dynamic_cast<MainguiWindow*>(qw)->inputvector(a);
	i = s.length();
	b = "";
	b.assign(s,1,i);
	s = strstr(b.c_str()," ");
	i = b.length();
	j = s.length();
	b.assign(b,0,i-j);
	dynamic_cast<MainguiWindow*>(qw)->state(b);
	i = s.length();
	c = "";
	c.assign(s,1,i);
	s = strstr(c.c_str()," ");
	i = c.length();
	j = s.length();
	c.assign(c,0,i-j);
	dynamic_cast<MainguiWindow*>(qw)->nextState(c);
	d = "";	
	d.assign(s,1,i);
	s = strstr(d.c_str()," ");
	i = d.length();
	j = s.length();
	d.assign(d,0,i-j);
	dynamic_cast<MainguiWindow*>(qw)->currentTime(d);
	dynamic_cast<MainguiWindow*>(qw)->simulationstep();
	//cout << "a: " << a << " b: " << b << " c: " << c << " d: " << d << endl; 
      } 
      //sleep(1);
    }
    free(buffer);
    close(fd);    
  }
