/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file testbenchhandler.h
  \brief TestbenchHandler

  \author Frank Lemke
  \date 2006-09-19
*/


#ifndef TESTBENCHHANDLER_H_
#define TESTBENCHHANDLER_H_

#include <string>
#include <cstdlib>
#include <vector>
#include <iterator>

#include <QtGui/QDialog>

#include <xercesc/sax2/DefaultHandler.hpp>
#include "../XercesDefinitions.hpp"

XERCES_CPP_NAMESPACE_USE

using namespace std;

/*!
  \brief TestbenchHandler
  
  Implementation of default handler for sax-parser. Needed for generating testbench for saved FSMs.
*/

class TestbenchHandler : public DefaultHandler, public QDialog {
  
 private:
  string project;
  string fsmname;
  vector <string> ins;
  vector <string> outs;
  string names;
  string directory;
  bool inflag;
  bool outflag;
  bool write;

 public:
  TestbenchHandler();
  TestbenchHandler(string outdir);
  void startElement(const XMLCh* const uri, const XMLCh* const localname, const XMLCh* const qname, const Attributes& att);
  void endElement(const XMLCh* const uri, const XMLCh* const localname, const XMLCh* const qname);
  void startDocument();
  void endDocument();
  void characters (const XMLCh* const chars, const unsigned long length);
  void fatalError(const SAXParseException& exc);
  void warning(const SAXParseException& exc);
  void error(const SAXParseException& exc);
};


#endif
