/***********************************************************************
*                                                                      *
* (C) 2006, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

/*!
  \file xmlload.h 
  \brief Xmlload
  
  \author Frank Lemke
  \date 2006-03-02
*/

#ifndef XMLLOAD_H_
#define XMLLOAD_H_

#include <string>
#include <cstdlib>

#include <xercesc/sax2/SAX2XMLReader.hpp>
#include <xercesc/sax2/XMLReaderFactory.hpp>
#include <xercesc/sax2/DefaultHandler.hpp>
#include <xercesc/util/XMLString.hpp>

#include "../load_I.h"


/*!
  \brief xmlload
  
  Xmlload provides a function to load a FSM stored in the defined format.
  The function createdtd creates the used structural definition.
*/

class Xmlload : public Load_I {

 public:
  Xmlload();
  ~Xmlload(){};

  /*!
    \brief load 

    Function to load a FSM from a XML-file.

    \param filename Filename with complete relative path for loading with extension.


  */

  void load(string filename); 

/*!
    \brief loadProject 

    Function to load a project with all FSMs from a XML-file.

    \param filename Filename with complete relative path for loading with extension.


  */

  void loadProject(string filename);
};

#endif
